;
; Disclaimer:  Anything can blow up at any time.  This script is FREE and
;              UNSUPPORTED.  Use it at your own risk.


;ͻ
; Script Name: ERRDLG                                                      
;                                                                          
;    Customer: BORDB CIS forum members                                     
;                                                                          
;      Author: Don Goyette - CIS ID 71601,3624                             
;              VS Toolbox Software, Colorado Springs, CO                   
;                                                                          
; Create Date: September 3, 1992                                           
;                                                                          
; Description: Two Paradox 4.0 utility procedures:                         
;              1. WordWrap any length string to any number of lines        
;              2. Pop-up dialog box (use for Error display)                
;                                                                          
;Ķ
;                      <<  EMBEDED PROCEDURES  >>                          
;                                                                          
;  Procedure Name                   Description of Procedure               
; --------------------  -------------------------------------------------- 
; ErrorMsg              Display error to user                              
; WordWrap              Break a long string into several at " " or "-"     
;                                                                          
;ͼ


;
Proc ErrorMsg()
;Ŀ
;                          << Proc Description >>                          
;                                                                          
;  Display an error message to the user via SHOWDIALOG.                    
;

;If the message is longer than the number of characters per line, then go
;have it wrapped into several lines...
   If Len(ErrorMsg.a) > 45 Then
      WordWrap(ErrorMsg.a, 3, 45)     ; (Text, # of lines, chars per line)
   Else
      Array WWText[3]
      WWText[1] = ErrorMsg.a          ; Only a single line, so set it and
      WWText[2] = " "                 ; clear the other two lines.
      WWText[3] = " "
   EndIf

   Sound 1000 150
   Sound 700  100
   Sound 1000 150
   Sound 700  100


;Display the dialog box...
   ShowDialog " << Error >> "
      @8,15 Height 8 Width 50


;Place the text message in the dialog box...
      @0,1
         ?? WWText[1]
      @1,1
         ?? WWText[2]
      @2,1
         ?? WWText[3]
      @3,0
         ?? Fill("",48)
      @4,3
         ?? "Press <Enter> to"
      @5,3
         ?? "acknowledge error."


;The only button we need is an Ok button...
      PushButton @4,29 Width 10
         "~O~k"
         Ok
         Default
         Value "Y"
         Tag "OkTag"
         To ErrorMsgAction


;Add a few color changes...
   PaintCanvas Attribute 79  0, 0, 2, 47
   PaintCanvas Attribute 127 3, 0, 5, 47

   EndDialog


;Get rid of the variables which were defined in WordWrap...
   Release Vars WWText, WWLineCount
   ErrorMsg.a = ""

EndProc ; ErrorMsg


;
Proc WordWrap(WWWorkText, WWMaxLines, WWCharPerLine)
;Ŀ
;                          << Proc Description >>                          
;                                                                          
;  Break a long string into multiple strings at " " or "-" characters.     
;

   Array WWText[WWMaxLines]
   WWCharPerLine = WWCharPerLine + 1


;Set each element of the array to a single space so they are all "defined"...
   For WWLineCount From 1 To WWMaxLines
      WWText[WWLineCount] = " "
   EndFor


;Wrap some Words...
   WWLineCount = 0

   While (True)
      WWLineCount = WWLineCount + 1

;Have we gone over the Maximum Allowable # of Lines?...
      If WWLineCount > WWMaxLines Then
         WWText[WWLineCount - 1] = Substr(WWText[WWLineCount - 1], 1,
            (Len(WWText[WWLineCount - 1]) - 14)) + "...[MSG TRUNCATED]"
         QuitLoop
      EndIf


;If the left-over line is within our # of chars per line, then use it...
      If Len(WWWorkText) < WWCharPerLine Then   ; The last line
         WWText[WWLineCount] = WWWorkText
         QuitLoop
      Else
         WWWorkLine = Substr(WWWorkText, 1, WWCharPerLine)
      EndIf


;Search for a blank " " or hyphen "-" to split the line...
      For Pos From WWCharPerLine To 1 Step -1
         If Substr(WWWorkLine, Pos, 1) = " "
         Or Substr(WWWorkLine, Pos, 1) = "-" Then
            WWText[WWLineCount] = Substr(WWWorkText, 1, Pos)
            WWWorkText = Substr(WWWorkText, Pos + 1, Len(WWWorkText))
            QuitLoop
         EndIf
      EndFor

   EndWhile

   Release Vars WWWorkText, WWMaxLines, WWCharPerLine, Pos, x

EndProc ; WordWrap


;
; Execute the "ErrorMsg with WordWrap" SHOWDIALOG test...

   ErrorMsg.a = "This is a very long message, just to see what happens when " +
                "it's displayed in a SHOWDIALOG box.  Now, we could even " +
                "add a few more characters to make it longer than the " +
                "allowable space to see what happens."

;   ErrorMsg.a = "Hello."

   ErrorMsg()

